#include <ctype.h>
#include <math.h>
#include <assert.h>
#include <fstream.h>
#include <string>
#include <strstream>

#ifdef DEBUG
#define DBG(x) x
#else
#define DBG(x)
#endif

#define inf 1000000000

ifstream file("formatting.in");

int n;
string word[11000];
int wordcount;
int l[11000];  // index starting by 1;
int ps[11000];
int prev[11000];
int penalty[11000];

int left(int i, int j)
{
  return n-(ps[j]-ps[i-1]+j-i);
}

int pen(int i, int j)
{
  assert(i<=j);
  if (i==j)
    {
      if (l[i]<n)
	return 500;
      else
	return 0;
      
    }
  else
    {
      int le=left(i,j);
      int res=0;
      for (int k=i; k<=j; k++)
	{
	  int sp=le/(j-i);
	  if (j-le%(j-i)<=k)
	    sp++;
	  res+=sp*sp;
	}
      return res;
    }
}


void output(int i, int j)
{
  //cout<<j<<' '<<i<<endl;
  assert(j>=i);
  int le=left(i,j);
  for (int k=i; k<=j; k++)
    {
      cout<<word[k];
      if (k==j) break;
      cout<<' ';
      for (int l=0; l<le/(j-i); l++)
	cout<<' ';
      if (j-le%(j-i)<=k) cout<<' ';
    }
  cout<<endl;
}

int main () {
  while(1)
    {
      string s;
      strstream str1;
      file>>ws;
      getline(file,s);
      str1<<s;
      str1>>n;
      wordcount=0;
      if (n==0) break;
      while (1)
	{
	  strstream str2;
	  getline(file,s);
	  str2<<s;
	  int wordn=0;
	  while (1)
	    {
	      string s;
	      str2>>s;
	      if (str2.fail())break;
	      word[wordcount+1]=s;
	      wordcount++;
	      wordn++;
	    }
	  if (wordn==0) break;
	}
      ps[0]=0;
      l[0]=0;
      for (int i=1; i<=wordcount; i++)
	{
	  l[i]=word[i].size();
	  ps[i]=ps[i-1]+l[i];
	}
      penalty[0]=0;
      prev[0]=0;
      
      for (int i=1; i<=wordcount; i++)
	{
	  penalty[i]=inf;
	  prev[i]=inf;
	  for (int j=i; left(j,i)>=0&&j>0; j--)
	    if (pen(j,i)+penalty[j-1]<penalty[i])
	      {
		penalty[i]=pen(j,i)+penalty[j-1];
		prev[i]=j-1;
	      }
	  assert(prev[i]!=inf);
	    
	}
      int k=wordcount;
      int ausg[10000];
      int i=0;
      while (k!=0)
	{
	  ausg[i]=k;
	  i++;
	  k=prev[k];
	}
      
      for (int j=i; j>0; j--)
	output(ausg[j]+1, ausg[j-1]);
      cout<<endl;
    }
}


