#include <ctype.h>
#include <math.h>
#include <assert.h>
#include <fstream.h>
#include <queue>
#include <string>
#include <strstream.h>

#ifdef DEBUG
#define DBG(x) x
#else
#define DBG(x)
#endif

#define inf 1000000

ifstream file("game.in");

int toindex(int x,int y, int d)
{
  return ((x*100)+y)*100+d;
}

void tokoor(int i, int& x, int& y, int& d)
{
  d=i%100;
  i/=100;
  y=i%100;
  i/=100;
  x=i;
}

queue <int> q;
int dir[4][2]={{1,0}, {0,1}, {-1,0}, {0,-1}};
char m[100][100];
int dist[100][100][5];

void insertall(int x, int y, int d, int distance)
{
  for (int j=0; ; j++)
    {
      assert (j<100);
      int xn=x+dir[d][0]*j;
      int yn=y+dir[d][1]*j;
      if (j>0&&m[xn][yn]=='X') break;
      if (dist[xn][yn][d]<=distance) continue;
      q.push(toindex(xn,yn,d));
      dist[xn][yn][d]=distance;
    }
}

int main () {
  for (int kase=1;; kase++)
    {
      int w,h;
      strstream str;
      string s2;
      file>>ws;
      getline(file,s2);
      str<<s2;
      str>>w>>h;
      if (w==0&&h==0) break;
      for (int i=0; i<w+4; i++)
	for (int j=0; j<h+4; j++)
	  m[i][j]='X';
      for (int i=1; i<w+3; i++)
	for (int j=1; j<h+3; j++)
	  m[i][j]=' ';
      for (int j=0; j<h; j++)
	{
	  string s;
	  getline(file,s);
	  for (int i=0; i<w; i++)
	    m[i+2][j+2]=s[i];
	}
      cout<<"Board #"<<kase<<":"<<endl;
      for (int pair =1; ; pair++)
	{
	  int x1,x2,y1,y2;
	  file>>x1>>y1>>x2>>y2;
	  if (x1==0&&x2==0&&y1==0&&y2==0)
	    break;
	  for (int i=0; i<w+4; i++)
	    for (int j=0; j<h+4; j++)
	      for (int k=0; k<4; k++)
		dist[i][j][k]=inf;
	  while (!q.empty()) q.pop();
	  for (int i=0; i<4; i++)
	    insertall(x1+1,y1+1,i, 1);
	  while (!q.empty())
	    {
	      int i=q.front();
	      q.pop();
	      int x,y,d;
	      tokoor(i,x,y,d);
	      for (int j=0; j<4; j++)
		if (j!=d)
		  {
		    int distance=dist[x][y][d]+1;
		    //		    if (j!=d) distance++;
		    //if (dist[x][y][j]<inf)
		    //  {
		    insertall(x,y,j,distance);
		    //  }
		}
	    }
	  cout<<"Pair "<<pair<<": ";
	  int lsmin=inf;
	  for (int i=0; i<4; i++)
	    {
	      lsmin = min(lsmin, dist[x2+1-dir[i][0]][y2+1-dir[i][1]][i]);
	    }
	  if (lsmin==inf) cout<<"impossible."<<endl;
	  else 
	    cout<<lsmin<<" segments."<<endl;
	}
      cout<<endl;
    }
  return 0;
}


